Exercise 6: Observer & Strategy Pattern
=======================================

IKI20810 - Advanced Programming @ Faculty of Computer Science 
Universitas Indonesia, Even Semester 2015/2016

* * *

*Friday, March 18th 2016*

Your main task in this exercise is to complete two modules (`observer.py` & 
`tabulator.py`) in order to demonstrate a working implementation of Observer 
and Strategy pattern. There are several methods that are left blank in 
`observer.py` that you need to complete. Additionally, there is a method in 
`observer.py` and a function in `tabulator.py` that you also need to fix 
in order to pass its unit test.

Starting from this week, several tasks in weekly exercises will require 
[PyCharm](https://www.jetbrains.com/pycharm/download/) and, preferably, 
done on your own machine (not on lab's PC). It is also recommended to get 
the student license as well via [this link](https://www.jetbrains.com/student/) 
to be able to use PyCharm Professional Edition and several other IDE offered 
by JetBrains.

Mandatory Tasks Description
---------------------------

The `observer.py` module contains the classes required to implement Observer 
pattern. The data model is represented as a class that extends `Observed` 
class. The view, or the observer, is represented as a class that extends 
`AbstractView` abstract class. Your tasks related to this module is to 
implement methods in `Observed` and `SliderModel`. There is also one method, 
`update()` in `LiveView` that you need to fix. The correct output that is 
generated when running the Observer pattern should be similar to the following 
picture.

![Observer pattern output](/img/observer_output.png)

The `tabulator.py` module contains functions that represent the algorithms to 
render a list of strings into a table form. `html_tabulator()` generates 
HTML representation, while `text_tabulator()` generates text representation. 
However, at its current state, a function is not working properly. You 
need to find out which function that is broken and fix it.

The output that should be generated by a correct implementation can be seen 
in the following pictures.

![Strategy pattern text output](/img/strategy_output_2.png)

![Strategy pattern HTML output](/img/correct_strategy_output_1.png)

When you found out the function that need to be fixed, you are required to 
use PyCharm's debugger feature to inspect how that function works. To use the 
debugger, you need to put a breakpoint at a line by clicking the line 
number on the editor view.

![Breakpoint example](/img/breakpoint.png)

Once you put a breakpoint, you need to tell PyCharm to run on debug mode. 
Right click on anywhere in the editor view and pick `Debug '[module]'` 
where `[module]` is name of module you want to debug. PyCharm will run 
the program and pause the flow just before it executes the line that 
has a breakpoint. 

When running the debugger, PyCharm will show additional panel that contain 
call stack of current program and variables that present in current scope. 
The panel also has Step buttons (Step Over, Step Into) that can be used to 
execute the next statement. You may also notice that PyCharm also display 
the value of each variables that is relevant to current scope 
directly in the editor view.

![Debugger view](/img/pycharm_debugger_view.png)

Please try using the debugger to know why the function does not work as 
expected. Once you have traced the source of the bug, fix it and ensure 
it passes the unit test.

Additional Tasks Description
----------------------------

There are two optional tasks that can give you extra credits. The first 
task is to implement a new observer called `AlertView` in `observer.py`. 
It works similarly to `HistoryView`, but it only append new data whenever 
the observed value is greater than or equal to a given threshold. The second 
task is to implement a new algorithm in `tabulator.py` that generates 
the HTML table with alternating row color. The example can be seen in the 
following picture.

![Alternating row color example](/img/alternate_row_example.png)

Running the Program
-------------------

The program (i.e. `week6.py`) accepts a parameter to determine which pattern 
to demonstrate. To run the program, type `python week6.py [pattern]` where 
`[pattern]` is the name of pattern that will be demonstrated. There are only 
two valid pattern name: `observer` and `strategy`. For example, if you want to 
run Observer pattern demonstration, execute `python week6.py observer` via 
command prompt/console. 

If you are using PyCharm, you can specify the parameter by using 
`Run -> Edit Configurations...` menu. The following picture shows an example 
of run configuration.

![Run config example in PyCharm](/img/run_config_pycharm.png) 


Mandatory Checklist
===================

* [ ] All tests in `ObservedTest` pass.
* [ ] Committed and pushed changes related to implementing `Observed` class.
* [ ] All tests in `SliderModelTest` pass.
* [ ] Committed and pushed changes related to implementing `SliderModel` class.
* [ ] Fixed `update()` in `LiveView` class.
* [ ] Committed and pushed changes related to fixing `update()` in `LiveView` class.
* [ ] Pinpointed the broken algorithm function in `tabulator.py`.
* [ ] Can demonstrate how to put a breakpoint. Please write the steps directly in the 
source code as comments.
* [ ] Can explain the reason why the algorithm function is broken after debugging the 
function. Please write the reason directly in the source code as comments. Hint: 
Inspect the content of the variable that holds the HTML string. 
* [ ] Fixed the broken algorithm function in `tabulator.py`.
* [ ] All tests in `HtmlTabulatorTest` pass.
* [ ] Committed and pushed changes related to debugging and fixing the broken 
algorithm function.

Additional Checklist
====================

* [ ] All tests in `AlertViewTest` pass.
* [ ] The program is able to print the output of `AlertView` 
correctly to standard output. Use standard output redirection 
when running the program.
* [ ] All tests in `AlternateTableRowHtmlTabulatorTest` pass.
* [ ] The program is able to print the output of alternating 
row color table algorithm to a HTML file. Use standard output 
redirection when running the program.

Additional Resources
====================

N/A
